function _toConsumableArray(r) { return _arrayWithoutHoles(r) || _iterableToArray(r) || _unsupportedIterableToArray(r) || _nonIterableSpread(); }
function _nonIterableSpread() { throw new TypeError("Invalid attempt to spread non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }
function _iterableToArray(r) { if ("undefined" != typeof Symbol && null != r[Symbol.iterator] || null != r["@@iterator"]) return Array.from(r); }
function _arrayWithoutHoles(r) { if (Array.isArray(r)) return _arrayLikeToArray(r); }
function _slicedToArray(r, e) { return _arrayWithHoles(r) || _iterableToArrayLimit(r, e) || _unsupportedIterableToArray(r, e) || _nonIterableRest(); }
function _nonIterableRest() { throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }
function _unsupportedIterableToArray(r, a) { if (r) { if ("string" == typeof r) return _arrayLikeToArray(r, a); var t = {}.toString.call(r).slice(8, -1); return "Object" === t && r.constructor && (t = r.constructor.name), "Map" === t || "Set" === t ? Array.from(r) : "Arguments" === t || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(t) ? _arrayLikeToArray(r, a) : void 0; } }
function _arrayLikeToArray(r, a) { (null == a || a > r.length) && (a = r.length); for (var e = 0, n = Array(a); e < a; e++) n[e] = r[e]; return n; }
function _iterableToArrayLimit(r, l) { var t = null == r ? null : "undefined" != typeof Symbol && r[Symbol.iterator] || r["@@iterator"]; if (null != t) { var e, n, i, u, a = [], f = !0, o = !1; try { if (i = (t = t.call(r)).next, 0 === l) { if (Object(t) !== t) return; f = !1; } else for (; !(f = (e = i.call(t)).done) && (a.push(e.value), a.length !== l); f = !0); } catch (r) { o = !0, n = r; } finally { try { if (!f && null != t.return && (u = t.return(), Object(u) !== u)) return; } finally { if (o) throw n; } } return a; } }
function _arrayWithHoles(r) { if (Array.isArray(r)) return r; }
import { IconFont } from '@zgfe/business-lib';
import { Button, Table } from 'antd';
import _ from 'lodash';
import React, { useEffect, useState } from 'react';
import ColumnName from './columnName';
import MappingInput from './mappingInput';
import { classPrefix } from './row2Column';
var AddList = function AddList(props) {
  var _useState = useState([]),
    _useState2 = _slicedToArray(_useState, 2),
    list = _useState2[0],
    setList = _useState2[1];
  useEffect(function () {
    var _ref;
    var res = (_ref = props.defaultValue || []) === null || _ref === void 0 ? void 0 : _ref.map(function (value) {
      return {
        key: Math.random(),
        value: /::/.test(value) ? value.split('::')[0] : value,
        mapping: /::/.test(value) ? value.split('::')[1] : ''
      };
    });
    setList(res.length ? res : [{
      key: Math.random(),
      value: ''
    }]);
  }, []);
  useEffect(function () {
    if (props.onChange) props.onChange(list.filter(function (item) {
      return item.value;
    }).map(function (item) {
      return "".concat(item.value, "::").concat(item.mapping);
    }));
  }, [list]);
  function onAdd() {
    setList(function (pre) {
      return [].concat(_toConsumableArray(pre), [{
        key: Math.random(),
        value: '',
        mapping: ''
      }]);
    });
  }
  function _onChange(value, record) {
    setList(function (pre) {
      var res = _.cloneDeep(pre);
      res.forEach(function (item) {
        if (item.key === record.key) {
          item.value = value;
        }
      });
      return res;
    });
  }
  function onChangeMapping(value, record) {
    setList(function (pre) {
      var res = _.cloneDeep(pre);
      res.forEach(function (item) {
        if (item.key === record.key) {
          item.mapping = value;
        }
      });
      return res;
    });
  }
  function onDel(record) {
    setList(function (pre) {
      var res = _.cloneDeep(pre);
      return res.filter(function (item) {
        return item.key !== record.key;
      });
    });
  }
  return /*#__PURE__*/React.createElement(Table, {
    columns: [{
      title: '列名',
      dataIndex: 'value',
      render: function render(value, record) {
        return /*#__PURE__*/React.createElement("div", {
          className: "".concat(classPrefix, "-edit-row")
        }, /*#__PURE__*/React.createElement(ColumnName, {
          defaultValue: value,
          onChange: function onChange(name) {
            _onChange(name, record);
          }
        }));
      }
    }, {
      title: (/*#__PURE__*/React.createElement(React.Fragment, null, "\u6620\u5C04\u503C", /*#__PURE__*/React.createElement(Button, {
        type: "link",
        onClick: onAdd,
        disabled: list.length >= 7
      }, "\u6DFB\u52A0"))),
      dataIndex: 'mapping',
      render: function render(val, record) {
        return /*#__PURE__*/React.createElement("div", {
          className: "".concat(classPrefix, "-edit-row")
        }, /*#__PURE__*/React.createElement(MappingInput, {
          defaultValue: val,
          onChange: function onChange(v) {
            onChangeMapping(v, record);
          }
        }), /*#__PURE__*/React.createElement(IconFont, {
          type: "shanchu1",
          className: list.length > 1 ? '' : 'disabled',
          onClick: function onClick() {
            if (list.length <= 1) return;
            onDel(record);
          }
        }));
      }
    }],
    pagination: false,
    dataSource: list,
    rowKey: "key"
  });
};
export default AddList;